unit main;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ExtCtrls, Emitter, Parser, Stack, Heap;

type
  TForm1 = class(TForm)
		GroupBox1: TGroupBox;
    memoIn: TMemo;
    GroupBox2: TGroupBox;
    memoOutput: TMemo;
		Panel1: TPanel;
		btnRun: TButton;
		procedure btnRunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
	private
		{ Private declarations }
		parser: TParser;
	public
		{ Public declarations }
	end;

var
	Form1: TForm1;

// =======================================================
implementation

{$R *.DFM}


// -----------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
	emit := TEmitter.Create(memoOutput);
	stak := TStack.Create;
	heep := THeap.Create;
end;

// -----------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
	heep.Free;
	stak.Free;
	emit.Free;
end;

// -----------------------------------------------------------------
procedure TForm1.btnRunClick(Sender: TObject);
var
	iMsgIndex: Integer;
begin
	try try

		parser := TParser.Create;


		emit.Emit('parsing...');
		parser.Parse(memoIn);
		emit.Emit('running...');
		parser.Root.CodeGen;
		emit.Emit('done.');

	except
		on e: ParseSyntaxErrorException do
			for iMsgIndex := 0 to parser.SyntaxErrorMessage.Count - 1 do
				emit.Emit(parser.SyntaxErrorMessage[iMsgIndex]);
		on e: Exception do
			emit.Emit('exception:  ' + e.Message);

	end;
	finally
		emit.Emit('');
		parser.Free;
	end;
end;


end.
